'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _fetchStates = require('../mapper/fetch-states');

var _fetchStates2 = _interopRequireDefault(_fetchStates);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function stateToAction(handleFetch, handleComplete, handleError, handleCancel) {
  return function (state) {

    switch (state) {
      case _fetchStates2.default.FETCH_STARTED:
        return handleFetch;
      case _fetchStates2.default.FETCH_COMPLETED:
        return handleComplete;
      case _fetchStates2.default.FETCH_ERROR:
        return handleError;
      case _fetchStates2.default.FETCH_CANCELLED:
        return handleCancel;
    };

    throw new Error('Unknown state : ' + state);
  };
};

exports.default = stateToAction;