'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _redux = require('redux');

var _actionBuilder = require('./action-builder');

var _actionBuilder2 = _interopRequireDefault(_actionBuilder);

var _defaultReducer = require('./default-reducer');

var _defaultReducer2 = _interopRequireDefault(_defaultReducer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createApiReducer(config) {
  var resourcesReducers = config.resources.reduce(function (acc, resource) {
    var name = resource.reducerName || resource.name;
    acc[name] = createResourceReducer(config, resource);
    return acc;
  }, {});

  return (0, _redux.combineReducers)(resourcesReducers);
};

function createResourceReducer(config, resource) {
  var endPointsReducers = resource.endPoints.reduce(function (acc, endPoint) {
    var actionBuilder = (0, _actionBuilder2.default)(resource, endPoint);
    var name = endPoint.reducerName || endPoint.name;

    if (endPoint.reducerBuilder) acc[name] = endPoint.reducerBuilder(actionBuilder);else if (resource.reducerBuilder) acc[name] = resource.reducerBuilder(actionBuilder);else if (config.reducerBuilder) acc[name] = config.reducerBuilder(actionBuilder);else {
      var reducerData = void 0;

      if (endPoint.reducerData !== undefined) reducerData = endPoint.reducerData;else if (resource.reducerData !== undefined) reducerData = resource.reducerData;else if (config.reducerData !== undefined) reducerData = config.reducerData;else reducerData = null;

      acc[name] = (0, _defaultReducer2.default)(reducerData)(actionBuilder);
    }
    return acc;
  }, {});

  return (0, _redux.combineReducers)(endPointsReducers);
};

exports.default = createApiReducer;